Index: sansview/perspectives/fitting/modelpage.py
===================================================================
--- sansview/perspectives/fitting/modelpage.py	(revision bb18ef1c74ed79eb0630f198735ad2b14e7913ab)
+++ sansview/perspectives/fitting/modelpage.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -1,3 +1,3 @@
-import sys
+
 import wx
 import wx.lib.newevent
@@ -12,8 +12,9 @@
 _BOX_WIDTH = 80
 
-
-
-
-class ModelPage(wx.ScrolledWindow):
+import basepage
+from basepage import BasicPage
+
+
+class ModelPage(BasicPage):
     """
         FitPanel class contains fields allowing to display results when
@@ -23,152 +24,62 @@
   
     """
-    ## Internal name for the AUI manager
-    window_name = "Fit page"
-    ## Title to appear on top of the window
-    window_caption = "Fit Page"
-    name=""
-    def __init__(self, parent,model,name, *args, **kwargs):
-        wx.ScrolledWindow.__init__(self, parent, *args, **kwargs)
+    def __init__(self,parent, page_info, name=""):
+        BasicPage.__init__(self, parent, page_info,name)
         """ 
             Initialization of the Panel
         """
-        # model on which the fit would be performed
-        self.model=model
-        # Data member to store the dispersion object created
-        self._disp_obj_dict = {}
-        self.back_up_model= model.clone()
-        #list of dispersion paramaters
-        self.disp_list=[]
-        try:
-            self.disp_list=self.model.getDispParamList()
-        except:
-            pass 
-        self.manager = None
-        self.parent  = parent
-        self.event_owner = None
-        # this panel does contain data .existing data allow a different drawing
-        #on set_model parameters
-        self.data=None
-        #panel interface
-        self.vbox  = wx.BoxSizer(wx.VERTICAL)
-        self.sizer11 = wx.BoxSizer(wx.HORIZONTAL)
-        #self.sizer10 = wx.GridBagSizer(5,5)
-        self.sizer9 = wx.GridBagSizer(5,5)
-        self.sizer8 = wx.GridBagSizer(5,5)
-        self.sizer7 = wx.GridBagSizer(5,5)
-        self.sizer6 = wx.GridBagSizer(5,5)
-        self.sizer5 = wx.GridBagSizer(5,5)
-        self.sizer4 = wx.GridBagSizer(5,5)
-       
-        #model selection
-        self.vbox.Add(wx.StaticLine(self, -1), 0, wx.EXPAND, 0)
-        self.vbox.Add(self.sizer4)
-        #model description
-        self.vbox.Add(self.sizer11)
-        #model paramaters layer
-        self.vbox.Add(self.sizer5)
-        #polydispersion selected
-        self.vbox.Add(wx.StaticLine(self, -1), 0, wx.EXPAND, 0)
-        self.vbox.Add(self.sizer6)
-        #combox box for type of dispersion
-        self.vbox.Add(self.sizer7)
-        #dispersion parameters layer
-        self.vbox.Add(self.sizer8)
-        # plotting range
-        self.vbox.Add(self.sizer9)
-        #close layer
-        #self.vbox.Add(wx.StaticLine(self, -1), 0, wx.EXPAND, 0)
-        #self.vbox.Add(self.sizer10)
-        
-      
-        #------------------ sizer 4  draw------------------------  
-       
-        ## structure combox box
-        self.structbox = wx.ComboBox(self, -1)
-        # define combox box
-        self.modelbox = wx.ComboBox(self, -1)
-        
-        #enable model 2D draw
-        self.enable2D= False
-        self.fitrange= True
-        #filling sizer2
-        ix = 0
-        iy = 1
-        self.sizer4.Add(wx.StaticText(self,-1,'Model'),(iy,ix),(1,1)\
-                  , wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-        ix += 1
-        self.sizer4.Add(self.modelbox,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix +=1
-        self.text_mult= wx.StaticText(self,-1,' x ')
-        self.sizer4.Add(self.text_mult,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        self.sizer4.Add(self.structbox,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        
-        if hasattr(model ,"model2"):
-            name= model.model2.name
-
-            self.structbox.SetValue(name)          
-        if hasattr(model ,"model1"):
-            name= model.model1.name
-            items = self.modelbox.GetItems()
-            self.modelbox.SetValue(name)
+        
+        self._fill_model_sizer( self.sizer1)  
+        self._fill_range_sizer() 
+        if hasattr(self.page_info,"model"):
+            model=self.page_info.model
+            description=""
+            if model!=None:
+                description = self.page_info.model.description
+            self.set_model_param_sizer(self.model)
+            self.set_model_description(description,self.sizer2)
+        
+    
+
+        
+    def _on_display_description(self, event):
+        """
+            Show or Hide description
+            @param event: wx.EVT_RADIOBUTTON
+        """
+        self._on_display_description_helper()
+        
+        
+        
+    def _on_display_description_helper(self):
+        """
+            Show or Hide description
+            @param event: wx.EVT_RADIOBUTTON
+        """
+        ## save state of radiobox
+        self.page_info. save_radiobox_state( self.description_hide )
+        self.page_info. save_radiobox_state( self.description_show )
+        ## Show description
+        if not self.description_show.GetValue():
+            self.sizer_description.Clear(True)
+            
         else:
-            #print "model view prev_model",name
-            self.modelbox.SetValue( name )
-        ix += 1
-        id = wx.NewId()
-        self.model_view =wx.Button(self,id,'View 2D')
-        self.model_view.Bind(wx.EVT_BUTTON, self.onModel2D,id=id)
-        self.model_view.SetToolTipString("View model in 2D")
-        
-        self.sizer4.Add(self.model_view,(iy,ix),(1,1),\
-                   wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-        
-        self.model_view.Enable()
-        self.model_view.SetFocus()
-        
-        ix = 0
-        iy += 1
-        self.sizer4.Add((20,20),(iy,ix),(1,1),wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-
-        #----------sizer6-------------------------------------------------
-        self.disable_disp = wx.RadioButton(self, -1, 'No', (10, 10), style=wx.RB_GROUP)
-        self.enable_disp = wx.RadioButton(self, -1, 'Yes', (10, 30))
-        self.Bind(wx.EVT_RADIOBUTTON, self.Set_DipersParam, id=self.disable_disp.GetId())
-        self.Bind(wx.EVT_RADIOBUTTON, self.Set_DipersParam, id=self.enable_disp.GetId())
-        ix= 0
-        iy=1
-        self.sizer6.Add(wx.StaticText(self,-1,'Polydispersity: '),(iy,ix),(1,1)\
-                  , wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-        ix += 1
-        self.sizer6.Add(self.enable_disp ,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        self.sizer6.Add(self.disable_disp ,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix =0
-        iy+=1
-        self.sizer6.Add((20,20),(iy,ix),(1,1),wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)  
-
-        
-        #---------sizer 9 draw----------------------------------------
-       
-         ## Q range
-        self.qmin_x= 0.001
-        self.qmax_x= 0.1
-        self.num_points= 100
-        
-        
-        self.qmin    = wx.TextCtrl(self, -1,size=(_BOX_WIDTH,20))
-        self.qmin.SetValue(format_number(self.qmin_x))
-        self.qmin.SetToolTipString("Minimun value of Q in linear scale.")
-        self.qmin.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-        self.qmin.Bind(wx.EVT_TEXT_ENTER, self._onparamEnter)
-     
-        self.qmax    = wx.TextCtrl(self, -1,size=(_BOX_WIDTH,20))
-        self.qmax.SetValue(format_number(self.qmax_x))
-        self.qmax.SetToolTipString("Maximum value of Q in linear scale.")
-        self.qmax.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-        self.qmax.Bind(wx.EVT_TEXT_ENTER, self._onparamEnter)
-     
-
+            model=self.page_info.model
+            description=""
+            if model!=None:
+                description = self.page_info.model.description
+            self.description = wx.StaticText( self,-1,str(description) )
+            self.sizer_description.Add( self.description, 1, wx.EXPAND | wx.ALL, 10 )
+           
+        self.Layout()
+    
+    
+    def _fill_range_sizer(self):
+        """
+            Fill the sizer containing the plotting range
+            add  access to npts
+        """
+        sizer_npts= wx.GridSizer(1, 1,5, 5)
+    
         self.npts    = wx.TextCtrl(self, -1,size=(_BOX_WIDTH,20))
         self.npts.SetValue(format_number(self.num_points))
@@ -176,259 +87,133 @@
         self.npts.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
         self.npts.Bind(wx.EVT_TEXT_ENTER, self._onparamEnter)
-       
-        ix = 0
-        iy = 1 
-        self.sizer9.Add(wx.StaticText(self, -1, 'Plotting Range'),(iy, ix),(1,1),\
-                            wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+        
+        sizer_npts.Add(wx.StaticText(self, -1, 'Npts'),1, wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 5)        
+        sizer_npts.Add(self.npts,1, wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 5) 
+        self._set_range_sizer( title="Plotted Q Range", object= sizer_npts)
+       
+    def _on_select_model(self, event): 
+        """
+             call back for model selection
+        """    
+        self._on_select_model_helper(event) 
+        self.set_model_param_sizer(self.model)
+        self._set_sizer_gaussian()
+        self.name = self.model.name
+        self.model_view.SetFocus()
+        self.parent.model_page.name = self.name
+        self.parent.draw_model_name = self.name
+        self._draw_model()  
+       
+    def _fill_model_sizer(self, sizer):
+        """
+            fill sizer containing model info
+        """
+        id = wx.NewId()
+        self.model_view =wx.Button(self,id,'View 2D')
+        self.model_view.Bind(wx.EVT_BUTTON, self._onModel2D,id=id)
+        self.model_view.SetToolTipString("View model in 2D")
+        
+        ## class base method  to add view 2d button    
+        self._set_model_sizer(sizer=sizer, title="Model",object= self.model_view )    
+    
+  
+    def _set_sizer_gaussian(self):
+        """
+            draw sizer with gaussian dispersity parameters
+        """
+        self.fittable_param=[]
+        self.fixed_param=[]
+        ##reset model dispersity to gaussian
+        self._reset_gaussian_dispers()
+        
+        self.sizer4_4.Clear(True)
+        if self.model==None:
+            ##no model is selected
+            return
+        if not self.enable_disp.GetValue():
+            ## the user didn't select dispersity display
+            return 
+        ix=0
+        iy=1
+        disp = wx.StaticText(self, -1, 'Names')
+        self.sizer4_4.Add(disp,( iy, ix),(1,1), 
+                           wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
         ix += 1 
-        self.sizer9.Add(wx.StaticText(self, -1, 'Min'),(iy, ix),(1,1),\
-                            wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        self.sizer9.Add(wx.StaticText(self, -1, 'Max'),(iy, ix),(1,1),\
-                            wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        self.sizer9.Add(wx.StaticText(self, -1, 'Npts'),(iy, ix),(1,1),\
-                            wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix = 0
-        iy += 1
-        self.sizer9.Add(wx.StaticText(self, -1, 'Q range'),(iy, ix),(1,1),\
-                            wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-        ix += 1
-        self.sizer9.Add(self.qmin,(iy, ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        self.sizer9.Add(self.qmax,(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        ix += 1
-        self.sizer9.Add(self.npts,(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        
+        values = wx.StaticText(self, -1, 'Values')
+        self.sizer4_4.Add(values,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+       
+        ix += 1 
+        npts = wx.StaticText(self, -1, 'Npts')
+        self.sizer4_4.Add(npts,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+        ix += 1 
+        nsigmas = wx.StaticText(self, -1, 'Nsigmas')
+        self.sizer4_4.Add(nsigmas,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+       
+        for item in self.model.dispersion.keys():
+            name1=item+".width"
+            name2=item+".npts"
+            name3=item+".nsigmas"
+            iy += 1
+            for p in self.model.dispersion[item].keys():
+                if p=="width":
+                    ix = 0
+                    name = wx.StaticText(self, -1,  name1)
+                    self.sizer4_4.Add( name,( iy, ix),(1,1),  
+                                       wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+                    ix = 1
+                    value= self.model.getParam(name1)
+                    ctl1 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH,20),
+                                        style=wx.TE_PROCESS_ENTER)
+                    
+                    ctl1.SetValue(str (format_number(value)))
+                    ctl1.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
+                    ctl1.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                    self.sizer4_4.Add(ctl1, (iy,ix),(1,1), wx.EXPAND)
+                    
+                    self.fittable_param.append([None,name1,ctl1,None,
+                                                None, None, None,None])
+                    
+                elif p=="npts":
+                        ix =2
+                        value= self.model.getParam(name2)
+                        Tctl1 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20),
+                                            style=wx.TE_PROCESS_ENTER)
+                        
+                        Tctl1.SetValue(str (format_number(value)))
+                        Tctl1.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
+                        Tctl1.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                        self.sizer4_4.Add(Tctl1, (iy,ix),(1,1),
+                                           wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+                        
+                        self.fixed_param.append([None,name2, Tctl1,None,None,
+                                                  None, None,None])
+                
+                elif p=="nsigmas":
+                        ix =3 
+                        value= self.model.getParam(name3)
+                        Tctl2 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20),
+                                            style=wx.TE_PROCESS_ENTER)
+                        Tctl2.SetValue(str (format_number(value)))
+                        Tctl2.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
+                        Tctl2.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                        self.sizer4_4.Add(Tctl2, (iy,ix),(1,1),
+                                           wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+                        ix +=1
+                        self.sizer4_4.Add((20,20), (iy,ix),(1,1),
+                                           wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+                        
+                        self.fixed_param.append([None,name3, Tctl2,
+                                                 None,None, None, None,None])
+        
+        msg = " Selected Distribution: Gaussian"        
+        wx.PostEvent(self.parent.parent, StatusEvent( status= msg ))   
         ix =0
-        iy+=1 
-        self.sizer9.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        
-        # contains link between  model ,all its parameters, and panel organization
-        self.parameters=[]
-        self.fixed_param=[]
-        self.fittable_param=[]
-        self.polydisp= {}
-        #contains link between a model and selected parameters to fit 
-        self.param_toFit=[]
-        
-        #dictionary of model name and model class
-        self.model_list_box={}
-        #Draw initial panel
-         #-----sizer 11--------------------model description------
-        if self.model!=None:
-            self.set_panel(self.model)
-        self.theta_cb=None
-        
-       
-        self.vbox.Layout()
-        self.vbox.Fit(self) 
-        self.SetSizer(self.vbox)
-        self.SetScrollbars(20,20,55,40)
-        
-        self.Centre()
-        self.Layout()
-        self.parent.GetSizer().Layout()
-    def set_model_description(self, model=None):
-        
-        if model !=None:
-            description="description"
-        else:
-            description=""
-            if hasattr(model,description.lower())and self.data==None:
-                self.sizer11.Clear(True)
-                self.box_description= wx.StaticBox(self, -1, 'Model Description')
-                boxsizer1 = wx.StaticBoxSizer(self.box_description, wx.VERTICAL)
-                boxsizer1.SetMinSize((320,20))
-                self.description = wx.StaticText(self,-1,str(model.description))
-                boxsizer1.Add(self.description, 0, wx.EXPAND)  
-                self.sizer11.Add(boxsizer1,1, wx.EXPAND | wx.ALL, 2)
-      
-        
-    def set_owner(self,owner):
-        """ 
-            set owner of fitpage
-            @param owner: the class responsible of plotting
-        """
-        self.event_owner=owner    
-   
-  
-    def set_manager(self, manager):
-        """
-             set panel manager
-             @param manager: instance of plugin fitting
-        """
-        self.manager = manager  
-        
-    def populate_box(self, dict):
-        """
-            Populate each combox box of each page
-            @param page: the page to populate
-        """
-        
-        self.model_list_box = dict.get_list()
-       
-        for item , mylist in self.model_list_box.iteritems():
-            separator= "---%s---"%item
-            self.modelbox.Append(separator,"separator")
-            
-            for models in mylist:
-                model= models()
-                name = model.__class__.__name__
-                if hasattr(model, "name"):
-                    name = model.name
-                self.modelbox.Append(name,models)
-            wx.EVT_COMBOBOX(self.modelbox,-1, self._on_select_model)
-            if item == "Structure Factors" :
-                for structs in mylist:
-                    struct= structs()
-                    name = struct.__class__.__name__
-                    if hasattr(struct, "name"):
-                        name = struct.name
-                    self.structbox.Append(name,structs)
-                wx.EVT_COMBOBOX(self.structbox,-1, self._on_select_model)
-        
-        
-        return 0
-    
-
-    def Set_DipersParam(self, event):
-        if self.model ==None:
-            msg= " Select non - model value:%s !"%self.model
-            wx.PostEvent(self.parent.parent, StatusEvent(status= msg))
-            return 
-        if self.enable_disp.GetValue():
-            if len(self.disp_list)==0:
-                ix=0
-                iy=1
-                self.fittable_param=[]
-                self.fixed_param=[]
-                self.sizer8.Clear(True)
-                model_disp = wx.StaticText(self, -1, 'No PolyDispersity for this model')
-                self.sizer7.Add(model_disp,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-                self.vbox.Layout()
-                self.SetScrollbars(20,20,55,40)
-                self.Layout()
-                self.parent.GetSizer().Layout()
-                return 
-            else:
-                if self.data !=None and self.model !=None: # allow to recognize data panel from model panel
-                    
-                
-                    self.cb1.SetValue(False)
-                    self.select_all_param_helper()
-                
-                self.populate_disp_box()
-                self.set_panel_dispers(self.disp_list)
-                
-        else:
-            if self.data !=None and self.model!=None:
-                if self.cb1.GetValue():
-                    self.select_all_param_helper()
-            
-            if self.back_up_model!=None:
-                keys = self.back_up_model.getDispParamList()
-                keys.sort()
-                #disperse param into the initial state
-                for item in keys:
-                    value= self.back_up_model.getParam(item)
-                    self.model.setParam(item, value)
-                self._draw_model() 
-            
-                
-            self.fittable_param=[]        
-            self.fixed_param=[]
-            self.sizer7.Clear(True)
-            self.sizer8.Clear(True)
-            self.vbox.Layout()
-            self.SetScrollbars(20,20,55,40)
-            self.Layout()
-            self.parent.GetSizer().Layout()
-            
-    def populate_disp_box(self):
-        self.sizer7.Clear(True)
-        if len(self.disp_list)>0:
-            ix=0
-            iy=1
-            model_disp = wx.StaticText(self, -1, 'Model Disp')
-            self.sizer7.Add(model_disp,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-            ix += 1 
-            # set up the combox box
-            id = 0
-            import sans.models.dispersion_models 
-            self.polydisp= sans.models.dispersion_models.models
-            self.disp_box = wx.ComboBox(self, -1)
-            self.disp_box.SetValue("GaussianModel")
-            for k,v in self.polydisp.iteritems():
-                if str(v)=="MyModel":
-    				# Remove the option until the rest of the code is ready for it
-                    #self.disp_box.Insert("Select customized Model",id)
-                    pass  
-                else:
-                    self.disp_box.Insert(str(v),id)         
-                id+=1
-            
-            wx.EVT_COMBOBOX(self.disp_box,-1, self._on_select_Disp) 
-            self.sizer7.Add(self.disp_box,( iy, ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-            self.vbox.Layout()
-            self.SetScrollbars(20,20,55,40)
-            self.Layout()
-            self.parent.GetSizer().Layout()  
-            
-            
-    def set_range(self, qmin_x, qmax_x, npts):
-        """
-            Set the range for the plotted models
-            @param qmin: minimum Q
-            @param qmax: maximum Q
-            @param npts: number of Q bins
-        """
-        # Set the data members
-        self.qmin_x = qmin_x
-        self.qmax_x = qmax_x
-        self.num_points = npts
-        
-        # Set the controls
-        self.qmin.SetValue(format_number(self.qmin_x))
-        self.qmax.SetValue(format_number(self.qmax_x))
-        self.npts.SetValue(format_number(self.num_points))
-    def checkFitRange(self):
-        """
-            Check the validity of fitting range
-            @note: qmin should always be less than qmax or else each control box
-            background is colored in pink.
-        """
-       
-        flag = True
-        valueMin = self.qmin.GetValue()
-        valueMax = self.qmax.GetValue()
-        # Check for possible values entered
-        #print "fitpage: checkfitrange:",valueMin,valueMax
-        try:
-            if (float(valueMax)> float(valueMin)):
-                self.qmax.SetBackgroundColour(wx.WHITE)
-                self.qmin.SetBackgroundColour(wx.WHITE)
-            else:
-                flag = False
-                self.qmin.SetBackgroundColour("pink")
-                self.qmax.SetBackgroundColour("pink")      
-        except:
-            flag = False
-            self.qmin.SetBackgroundColour("pink")
-            self.qmax.SetBackgroundColour("pink")
-            
-        self.qmin.Refresh()
-        self.qmax.Refresh()
-        return flag
-    
-
-        
-    def onClose(self,event):
-        """ close the page associated with this panel"""
-        self.parent.onClose()
-        
-  
-        
-    def onModel2D(self, event):
+        iy +=1 
+        self.sizer4_4.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)   
+        self.sizer4_4.Layout()
+        self.sizer4.Layout()
+        self.SetScrollbars(20,20,200,100)
+             
+    def _onModel2D(self, event):
         """
          call manager to plot model in 2D
@@ -442,7 +227,5 @@
             self._draw_model()
             self.model_view.Disable()
-       
-            
-    
+   
     def select_model(self, model, name):
         """
